<app-loading *ngIf="isLoading"></app-loading>

<nz-card class="card-header">
  <div class="action-breadcrumb-float-right" *ngIf="screenCode !== screenCodeConst.LDDV">
    <mb-button
      mbButtonAvailableStyle="PRIMARY"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.add' | translate }}"
      (click)="create()">
    </mb-button>
    <mb-button
      mbButtonAvailableStyle="BORDER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.merge' | translate }}"
      *ngIf="checkMergePropose()"
      (click)="mergePropose()">
    </mb-button>
  </div>
  <form nz-form>
    <div nz-row [nzGutter]="[16, 16]">
      <div nz-col class="gutter-row" nzLg="6">
        <mb-select
          [(ngModel)]="params.formGroup"
          name="formGroup"
          [mbDataSelects]="dataCommon.formGroupList"
          mbKeyLabel="name"
          mbKeyValue="id"
          mbLabelText="{{ 'development.proposed-unit.table.groupForm' | translate }}"
          mbPlaceholder="{{ 'development.proposed-unit.table.groupForm' | translate }}"
        >
        </mb-select>
      </div>
      <div nz-col class="gutter-row" nzLg="6">
        <span class="emp-infoTitle">{{ 'development.proposed-unit.table.proposeCode' | translate }}</span>
        <nz-input-number
          nz-input
          nzPlaceHolder="{{ 'development.proposed-unit.table.proposeCode' | translate }}"
          [nzMin]="0"
          [(ngModel)]="params.proposeCode"
          name="proposeCode"
          class="proposeCode"
        ></nz-input-number>
      </div>
      <div nz-col class="gutter-row" nzLg="6">
        <span class="card-header__rangeDateTitle">{{
          'development.proposed-unit.table.sentDate' | translate
        }}</span>
        <nz-range-picker
          [(ngModel)]="params.rangeDate"
          class="card-header__rangeDate"
          name="proposeDate"
          nzFormat="dd/MM/yyyy"
          [nzPlaceHolder]="['dd/mm/yyyy', 'dd/mm/yyyy']"
        ></nz-range-picker>
      </div>
      <div nz-col class="gutter-row" nzLg="6">
        <mb-select
          [(ngModel)]="params.approve"
          name="statusApprove"
          [mbDataSelects]="dataCommon.flowStatusApproveConfigList"
          mbKeyLabel="role"
          mbKeyValue="key"
          mbLabelText="{{
            'development.proposed-unit.table.statusApprove' | translate
          }}"
          mbPlaceholder="{{
            'development.proposed-unit.table.statusApprove' | translate
          }}"
        ></mb-select>
      </div>
    </div>
    <div *ngIf="!isExpand">
      <div nz-row [nzGutter]="[16, 8]">
        <div
          nz-col
          class="gutter-row"
          nzLg="6"
          *ngIf="screenCode === screenCodeConst.PTNL"
        >
          <mb-input-text
            [(ngModel)]="params.optionNote"
            name="contentPlan"
            [mbMaxLength]="50"
            mbLabelText="{{
              'development.proposed-unit.table.contentPlan' | translate
            }}"
            mbPlaceholderText="{{
              'development.proposed-unit.table.contentPlan' | translate
            }}"
          >
          </mb-input-text>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-select
            [(ngModel)]="params.statusPublish"
            name="statusPublish"
            [mbDataSelects]="dataCommon.flowStatusPublishConfigList"
            mbKeyLabel="role"
            mbKeyValue="key"
            mbLabelText="{{ 'development.proposed-unit.table.statusPublish' | translate }}"
            mbPlaceholder="{{ 'development.proposed-unit.table.statusPublish' | translate }}"
          ></mb-select>

        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-input-text
            [(ngModel)]="params.employeeCode"
            name="employeeCode"
            [mbMaxLength]="20"
            mbLabelText="{{ 'development.proposed-unit.table.empCode' | translate }}"
            mbPlaceholderText="{{ 'development.proposed-unit.table.empCode' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-input-text
            [(ngModel)]="params.employeeName"
            name="employeeName"
            [mbMaxLength]="50"
            mbLabelText="{{
              'development.proposed-unit.table.empName' | translate
            }}"
            mbPlaceholderText="{{
              'development.proposed-unit.table.empName' | translate
            }}"
          >
          </mb-input-text>
        </div>
        <div
          nz-col
          class="gutter-row"
          nzLg="6"
          *ngIf="screenCode !== screenCodeConst.PTNL"
        ></div>
        <div
          nz-col
          class="gutter-row"
          nzLg="6"
          *ngIf="screenCode === screenCodeConst.PTNL"
        >
          <mb-select
            [mbDataSelects]="dataCommon.issueLevelList"
            mbKeyLabel="name"
            mbKeyValue="code"
            [(ngModel)]="params.issueLevelCode"
            name="issueLevelCode"
            mbLabelText="{{ 'development.list-plan.table.14' | translate }}"
            mbPlaceholder="{{ 'development.list-plan.table.14' | translate }}"
          ></mb-select>
        </div>
        <div nz-col class="gutter-row" nzLg="6" *ngIf="screenCode === screenCodeConst.PTNL">
          <mb-input-text
            [(ngModel)]="params.approvalFullName"
            name="approvalFullName"
            [mbMaxLength]="20"
            mbLabelText="{{ 'development.list-plan.search.signerCode' | translate }}"
            mbPlaceholderText="{{ 'development.list-plan.search.signerCode' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-select-unit
            [(ngModel)]="params.currentUnit"
            mbLabelText="{{ 'development.proposed-unit.table.currentUnit' | translate }}"
            mbPlaceholder="{{ 'development.proposed-unit.table.currentUnit' | translate }}"
            name="currentUnit"
          >
          </mb-select-unit>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-select
            [(ngModel)]="params.currentTitle"
            name="currentTitle"
            [mbDataSelects]="dataCommon.jobDTOS"
            mbKeyLabel="jobName"
            mbKeyValue="jobId"
            mbLabelText="{{ 'development.proposed-unit.table.currentTitle' | translate }}"
            mbPlaceholder="{{ 'development.proposed-unit.table.currentTitle' | translate }}"
          ></mb-select>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-select-unit
            [(ngModel)]="params.proposeUnit"
            mbLabelText="{{ 'development.proposed-unit.table.proposeUnit' | translate }}"
            mbPlaceholder="{{ 'development.proposed-unit.table.proposeUnit' | translate }}"
            name="proposeUnit"
          >
          </mb-select-unit>
        </div>
        <div nz-col class="gutter-row" nzLg="6">
          <mb-select
            [(ngModel)]="params.proposeTitle"
            name="proposeTitle"
            [mbDataSelects]="dataCommon.jobDTOS"
            mbKeyLabel="jobName"
            mbKeyValue="jobId"
            mbLabelText="{{
              'development.proposed-unit.table.proposeTitle' | translate
            }}"
            mbPlaceholder="{{
              'development.proposed-unit.table.proposeTitle' | translate
            }}"
          >
          </mb-select>
        </div>
        <ng-container *ngIf="screenCode === screenCodeConst.PTNL">
          <div nz-col class="gutter-row" nzLg="6">
            <mb-select
              [(ngModel)]="params.conditionViolation"
              name="resultCheckCondition"
              [mbDataSelects]="dataCommon.conditionViolationList"
              mbKeyLabel="role"
              mbKeyValue="key"
              mbLabelText="{{
                'development.proposed-unit.table.resultCheckCondition2'
                  | translate
              }}"
              mbPlaceholder="{{
                'development.proposed-unit.table.resultCheckCondition2'
                  | translate
              }}"
            >
            </mb-select>
          </div>
          <div nz-col class="gutter-row" nzLg="6">
            <mb-select
              [(ngModel)]="params.consultationStatus"
              name="consultationStatus"
              [mbDataSelects]="dataCommon.consultationStatus"
              mbKeyLabel="name"
              mbKeyValue="code"
              mbLabelText="{{
                'development.proposed-unit.table.consultationCondition'
                  | translate
              }}"
              mbPlaceholder="{{
                'development.proposed-unit.table.consultationCondition'
                  | translate
              }}"
            >
            </mb-select>
          </div>
          <div nz-col class="gutter-row" nzLg="6">
            <mb-select
              [(ngModel)]="params.interviewStatus"
              name="interviewStatus"
              [mbDataSelects]="dataCommon.interviewStatus"
              mbKeyLabel="name"
              mbKeyValue="code"
              mbLabelText="{{
                'development.proposed-unit.table.interviewCondition' | translate
              }}"
              mbPlaceholder="{{
                'development.proposed-unit.table.interviewCondition' | translate
              }}"
            >
            </mb-select>
          </div>
          <div nz-col class="gutter-row" nzLg="6">
            <div nz-row [nzGutter]="12">
              <div nz-col class="gutter-row" nzLg="12">
                <label
                  nz-checkbox
                  [(ngModel)]="params.proposeGroup"
                  name="proposeGroup"
                  class="card-header__proposeCheckbox"
                >
                  {{
                    'development.proposed-unit.table.proposeMerge' | translate
                  }}
                </label>
              </div>
              <div nz-col class="gutter-row" nzLg="12">
                <label
                  nz-checkbox
                  [(ngModel)]="params.proposeOrigin"
                  name="proposeOrigin"
                  class="card-header__proposeCheckbox"
                >
                  {{
                    'development.proposed-unit.table.proposeOriginal'
                      | translate
                  }}
                </label>
              </div>
            </div>
          </div>
          <div nz-col class="gutter-row" nzLg="6">
            <label
              nz-checkbox
              [(ngModel)]="params.proposeItem"
              name="proposeItem"
              class="card-header__proposeCheckbox"
            >
              {{
                'development.proposed-unit.table.proposeComponents' | translate
              }}
            </label>
          </div>
        </ng-container>
      </div>
    </div>
  </form>
  <div nz-row [nzGutter]="12" class="card-header__btnGroup">
    <div nz-col nzLg="9"></div>
    <div nz-col nzLg="6">
      <mb-button
        mbButtonAvailableStyle="DEFAULT"
        mbButtonSize="LARGE"
        mbButtonText="{{ 'development.formLD.button.search' | translate }}"
        (click)="search(1)"
      >
      </mb-button>
      <mb-button
        mbButtonAvailableStyle="BORDER"
        mbButtonSize="VERY_LARGE"
        (click)="expandSearch()"
      >
        <span>
          <em nz-icon nzType="{{ iconStatus }}"></em>
        </span>
      </mb-button>
      <mb-button
        mbButtonAvailableStyle="BORDER"
        [disabled]="isLoading"
        mbButtonSize="LARGE"
        (click)="exportExcel()"
      >
        <img class="excelIcon" src="assets/images/icon/excel.svg" alt="" />
      </mb-button>
    </div>
    <div nz-col nzLg="9"></div>
  </div>
</nz-card>

<mb-table-wrap [mbTitle]="''">
  <mb-table
    (changePageNum)="search($event)"
    [tableConfig]="tableConfig"
    [tableData]="dataTable"
    [heightTable]="heightTable"
    (onDblClickNode)="detail($event)"
  >
  </mb-table>
</mb-table-wrap>

<ng-template #groupCBHeaderTmpl let-indexFix="indexFix">
  <label
    nz-checkbox
    [nzChecked]="checked"
    (nzCheckedChange)="onAllChecked($event)"
  >
  </label>
</ng-template>

<ng-template #groupCBTmpl let-indexFix="indexFix">
  <label
    nz-checkbox
    [nzChecked]="quantityMap.has(indexFix!)"
    (nzCheckedChange)="onItemChecked(indexFix, $event)"
    *ngIf="screenCode === screenCodeConst.PTNL && showCheckBox(indexFix)"
  >
  </label>
</ng-template>

<ng-template #conditionViolationTmpl let-conditionViolationCode="conditionViolationCode">
  <span>{{ checkConditionViolationCode(conditionViolationCode) }}</span>
</ng-template>

<ng-template #salaryStatusTmpl let-salaryStatus="salaryStatus">
  <nz-tag
    [nzColor]="displayStatus(salaryStatus)"
    class="data-table__statusDisplay"
    *ngIf="salaryStatus"
  >
    {{ salaryStatus }}
  </nz-tag>
</ng-template>

<ng-template #interviewStatusTmpl let-interviewStatus="interviewStatus">
  <nz-tag
    [nzColor]="displayStatus(interviewStatus)"
    *ngIf="interviewStatus"
    class="text-ellipsis data-table__statusDisplay"
    nz-tooltip
    nzTooltipPlacement="top"
    [nzTooltipTitle]="interviewStatus"
  >
    {{ interviewStatus }}
  </nz-tag>
</ng-template>

<ng-template
  #consultationStatusTmpl
  let-consultationStatus="consultationStatus"
>
  <nz-tag
    [nzColor]="displayStatus(consultationStatus)"
    *ngIf="consultationStatus"
    class="text-ellipsis data-table__statusDisplay"
    nz-tooltip
    nzTooltipPlacement="top"
    [nzTooltipTitle]="consultationStatus"
  >
    {{ consultationStatus }}
  </nz-tag>
</ng-template>

<ng-template #statusDisplayTmpl let-statusDisplay="statusDisplay">
  <nz-tag
    [nzColor]="displayStatus(statusDisplay)"
    class="data-table__statusDisplay"
    *ngIf="statusDisplay"
  >
    {{ statusDisplay }}
  </nz-tag>
</ng-template>

<ng-template #sentDateTmpl let-sentDate="sentDate">
  <span class="sentDate">{{ sentDate | date: 'dd/MM/yyyy' }}</span>
</ng-template>

<ng-template
  #statusPublishDisplayTmpl
  let-statusPublishDisplay="statusPublishDisplay"
>
  <nz-tag
    [nzColor]="displayStatus(statusPublishDisplay)"
    *ngIf="statusPublishDisplay"
    class="text-ellipsis data-table__statusDisplay"
    nz-tooltip
    nzTooltipPlacement="top"
    [nzTooltipTitle]="statusPublishDisplay"
  >
    {{ statusPublishDisplay }}
  </nz-tag>
</ng-template>

<ng-template
  #actionTmpl
  let-indexFix="indexFix"
  let-flowStatusCode="flowStatusCode"
  let-groupProposeTypeId="groupProposeTypeId"
  let-proposeId="proposeId"
>
  <!-- nút 3 chấm của PTNL -->
  <em
    nz-icon
    class="listEmpIconButton"
    nz-button
    nzType="more"
    nzTheme="outline"
    nzTrigger="click"
    nz-dropdown
    [nzDropdownMenu]="menu"
    [nzClickHide]="true"
    *ngIf="
      (checkHandle(indexFix) ||
      checkUpdate(flowStatusCode, indexFix) ||
      checkDelete(flowStatusCode, groupProposeTypeId, indexFix))
      && screenCode === screenCodeConst.PTNL
    "
  >
  </em>
  <nz-dropdown-menu #menu="nzDropdownMenu">
    <ul nz-menu>
      <li
        nz-button
        nz-menu-item
        class="subButton_dropdown"
        (click)="handle(indexFix)"
        *ngIf="checkHandle(indexFix)"
      >
        <div class="menu__item">
          <em nz-icon nzType="setting" nzTheme="outline" class="icon_dropdown"></em>
          <span class="subDropdown_label">{{ 'development.proposed-unit.button.handle' | translate }}</span>
        </div>
      </li>


      <li
        nz-button
        nz-menu-item
        class="subButton_dropdown"
        *ngIf="checkUpdate(flowStatusCode, indexFix)"
        (click)="update(indexFix)"
      >
        <div class="menu__item">
          <em nz-icon nzType="edit" nzTheme="outline" class="icon_dropdown"></em>
          <span class="subDropdown_label">{{ 'development.proposed-unit.button.edit' | translate }}</span>
        </div>
      </li>
      <li
        nz-menu-item
        nz-button
        class="subButton_dropdown"
        (click)="deleteProposeLD(indexFix, groupProposeTypeId, $event)"
        *ngIf="checkDelete(flowStatusCode, groupProposeTypeId, indexFix)"
      >
        <div class="menu__item">
          <em nz-icon nzType="delete" nzTheme="outline" class="icon_dropdown"></em>
          <span class="subDropdown_label">{{ 'development.proposed-unit.button.delete' | translate }}</span>
        </div>
      </li>
    </ul>
  </nz-dropdown-menu>

  <!-- nút 3 chấm của HRĐV -->
  <em
    nz-icon
    class="listEmpIconButton"
    nz-button
    nzType="more"
    nzTheme="outline"
    nzTrigger="click"
    nz-dropdown
    [nzDropdownMenu]="menu1"
    [nzClickHide]="true"
    *ngIf="screenCode === screenCodeConst.HRDV && (checkUpdateButton(indexFix) || checkDeleteButtonHRDV(indexFix)) && checkButtonMoreHRDV(indexFix)"
  >
  </em>
  <nz-dropdown-menu #menu1="nzDropdownMenu">
    <ul nz-menu>
      <li
        nz-button
        nz-menu-item
        class="subButton_dropdown"
        (click)="update(indexFix)"
        *ngIf="checkUpdateButton(indexFix)"
      >
        <div class="menu__item">
          <em nz-icon nzType="edit" nzTheme="outline" class="icon_dropdown"></em>
          <span class="subDropdown_label">{{ 'development.proposed-unit.button.edit' | translate }}</span>
        </div>
      </li>

      <li
        nz-button
        nz-menu-item
        class="subButton_dropdown"
        *ngIf="checkDeleteButtonHRDV(indexFix)"
        (click)="delete(proposeId!, $event)"
      >
        <div class="menu__item">
          <em nz-icon nzType="delete" nzTheme="outline" class="icon_dropdown"></em>
          <span class="subDropdown_label">{{ 'development.proposed-unit.button.delete' | translate }}</span>
        </div>
      </li>
    </ul>
  </nz-dropdown-menu>
</ng-template>
